#include <linux/config.h>
#include <linux/module.h>
#include <linux/init.h>
#include <linux/kernel.h>
#include <linux/errno.h>
#include <linux/sched.h>
#include <linux/security.h>
#include <linux/capability.h>
#include <linux/mm.h>
#include <linux/mman.h>
#include <linux/slab.h>
#include <linux/smp_lock.h>
#include <linux/spinlock.h>
#include <linux/file.h>
#include <linux/ext2_fs.h>
#include <net/ip.h>		/* for sysctl_local_port_range[] */
#include <asm/uaccess.h>
#include <asm/semaphore.h>
#include <asm/ioctls.h>
#include "include/lids.h"
#include "include/lidsext.h"
#include "include/lidsif.h"
/*
 *	lids capability violate logging
 */ 

kernel_cap_t lids_cap_val = 0;

static char *lids_caps_desc[] =
{
	"CAP_CHOWN",    
	"CAP_DAC_OVERRIDE",     
	"CAP_DAC_READ_SEARCH", 
	"CAP_FOWNER",         
	"CAP_FSETID",        
	"CAP_KILL",    
	"CAP_SETGID",
	"CAP_SETUID",
	"CAP_SETPCAP", 
	"CAP_LINUX_IMMUTABLE", 
	"CAP_NET_BIND_SERVICE",
	"CAP_NET_BROADCAST",  
	"CAP_NET_ADMIN",     
	"CAP_NET_RAW",      
	"CAP_IPC_LOCK",    
	"CAP_IPC_OWNER",  
	"CAP_SYS_MODULE",
	"CAP_SYS_RAWIO", 
	"CAP_SYS_CHROOT", 
	"CAP_SYS_PTRACE", 
	"CAP_SYS_PACCT", 
	"CAP_SYS_ADMIN", 
	"CAP_SYS_BOOT",  
	"CAP_SYS_NICE",
	"CAP_SYS_RESOURCE",  
	"CAP_SYS_TIME",  
	"CAP_SYS_TTY_CONFIG",  
	"CAP_MKNOD",
	"CAP_LEASE",
	"CAP_HIDDEN",
	"CAP_KILL_PROTECTED",
	"CAP_PROTECTED",
	NULL
};

void  lids_cap_log(int cap)
{
	LIDS_DBG(":lids_cap =%lx, cap_effective=%x,cap=%d,lids_load=%d,lids_local_load=%d\n",current->security->lids_cap, current->cap_effective,cap,lids_load,lids_local_load);
	if (!cap_raised(lids_cap_val,cap))	
		lids_security_alert(" violated %s",lids_caps_desc[cap]);
}
